/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: ftp_event.h,v 1.5 2003/02/24 15:51:13 thepin Exp $
 */

#ifndef _FTP_EVENT_H
#define _FTP_EVENT_H
#include <sys/types.h>
/* local headers */
#include <ftp.h>
#include <ftp_object.h>


#define FTP_EVENT_CMD		0x1
#define FTP_EVENT_IRRUPT	0x2

/* Sub Commands for Interrupts */
#define FTP_EVENT_IRRUPT_QUIT	0x1

struct ftp_event {
	_ftp_item **ftp;
	int type;
	void *arg;
	FTP_EVENT_CALLBACK(callback);
	FTP_OBJECT_DECLARE;
	struct ftp_event *next;
};

/* contains the status of a set of events.*/
struct ftp_event_handler_status {
	ftp_request *rpnt;
	int status;
};

struct ftp_event_cb_info {
	_ftp_item *ftp;
	int code;
	int state;
	char *cmd;
	struct ftp_event_handler_status *estat;
	int estat_index;
	ftp_request *rpnt;
	char *buf;
	ftp_object **obj;
};


/* function prototypes. */
void ftp_event_setup_default(_ftp_item *);
int ftp_event_add_handler(_ftp_item *, int, void *, FTP_EVENT_CALLBACK(x));
ftp_event *ftp_event_find_entry(ftp_event *, int, void *);
struct ftp_event_cb_info *ftp_event_setup_info_data(_ftp_item *, int, ftp_request *, int, int, char *, ftp_object **);
void ftp_event_nonblock_finished(_ftp_item *, struct ftp_event_handler_status *, int, struct ftp_event_cb_info *);
void ftp_handle_events(_ftp_item **);

#endif
