/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui.h,v 1.18 2003/03/03 02:16:32 tgucio Exp $
 */

#ifndef GUI_H
#define GUI_H

#include <gtk/gtk.h>
/* local includes */
#include <ftp.h>


#define MAX_SIZE	10240
#define GOOD_SIZE	512
#define MED_SIZE	128
#define SMALL_SIZE	64

typedef struct {
	int *var;
	int value;
} t_toggle;

#if 0
#define FTP_MODE_NONE	0
#define FTP_MODE_NORMAL	1
#define FTP_MODE_FXP	2
typedef struct {
	int mode;
	GtkWidget *cleft;
	GtkWidget *cright;
	_ftp_item *ftp;
	_ftp_item *fxp;	/* only used in fxp mode. */
} gtk_ftp_frontend;
#endif

#define CLIST_MODE_LOCAL	1
#define CLIST_MODE_FTP		2
#define CLIST_MODE_FXP		3

#if 0
typedef struct {
	/* GtkWidget *tview; XXX not neccessary perhaps? */ 
	int tview_mode;		/* local list / ftp list / fxp list */
	_ftp_item **site;	/* local: ftp to which we are connected , fxp: fxp conn ftp: current ftp */
	_ftp_item **site2;	/* local: NULL ftp: (local:null) (fxp:fxp): fxp: (ftp) */
	struct _list *list_dir;
} gtk_tview_frontend;
#endif

extern void gui_quit(gpointer);
extern struct _list* ftp_main_connect(const char*, int, const char*, const char*, int);
extern int gui_connect_dialog(void);
int gui_dialog_connect_commit(GtkWidget *, GdkEventKey *, gpointer);
extern void gui_preferences_dialog(void);
extern void gui_about_dialog(void);
extern void toggle_cb(GtkObject*, gpointer);
extern void check_cb(GtkObject*, gpointer);
extern t_toggle * toggle_new(int *, int);
extern gchar* gui_convert_utf8(const char*);
extern gchar* gui_convert_locale(const char*);
#ifdef FUN
extern void gui_yomomma_dialog(void);
extern void gui_yomomma_set_label(GtkButton*, GtkWidget*);
extern void gui_cute_dialog(void);
extern void gui_cute_set_img(GtkWidget *win, GdkEventButton*);
#endif
extern int gui_dialog_file_exist(char*);
#endif
