/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_dnd.h,v 1.5 2003/02/24 15:51:19 thepin Exp $
 */

#ifndef _GUI_DND_H
#define _GUI_DND_H

#define DRAG_TAR_NAME_0    "text/plain"
#define DRAG_TAR_INFO_0    0
#define DRAG_TAR_NAME_1    "text/uri-list" 
#define DRAG_TAR_INFO_1    1
#define DRAG_TAR_NAME_2    "STRING"
#define DRAG_TAR_INFO_2    2


typedef struct _dnd_item dnd_item;

struct _dnd_item {
	void  (*begin_cb)        (GtkWidget *, GdkDragContext *, dnd_item *);
	void  (*end_cb)          (GtkWidget *, GdkDragContext *, dnd_item *);
	void  (*data_delete_cb)  (GtkWidget *, GdkDragContext *, dnd_item *);
	int   (*motion_cb)       (GtkWidget *, GdkDragContext *, gint, gint, guint, dnd_item *);
	void* (*data_request_cb) (GtkWidget *, GdkDragContext *, GtkSelectionData *, guint, guint, dnd_item *);
};

typedef struct {
	GdkDragAction action;
	void (*actions_cb) (GtkWidget *, GdkDragContext, gint, gint, guint, gpointer);
} dnd_actions;


/* prototypes */
dnd_item *gui_dnd_item_new();
dnd_actions *gui_dnd_actions_new();
void gui_dnd_setup(GtkWidget *, gpointer, gpointer, gpointer, gpointer, gpointer);
void gui_dnd_enable(GtkWidget *);
void gui_dnd_interaction(GtkWidget *, GtkWidget *, gpointer, GdkDragAction);
void gui_dnd_drag_begin_cb(GtkWidget *widget, GdkDragContext *dc, gpointer data);
void gui_dnd_drag_end_cb(GtkWidget *widget, GdkDragContext *dc, gpointer data);
gboolean gui_dnd_drag_motion_cb(GtkWidget *, GdkDragContext *, gint, gint, guint, gpointer);
void gui_dnd_drag_data_request_cb(GtkWidget *, GdkDragContext *, GtkSelectionData *, guint, guint, gpointer);
void gui_dnd_drag_data_received_cb(GtkWidget *, GdkDragContext *, gint, gint, GtkSelectionData *, guint, guint, gpointer);
void gui_dnd_drag_data_delete_cb(GtkWidget *, GdkDragContext *, gpointer);
void gui_dnd_tview_begin_cb(GtkWidget *, GdkDragContext *, dnd_item *);
int gui_dnd_tview_motion_cb(GtkWidget *, GdkDragContext *, gint, gint, guint, dnd_item *);
void *gui_dnd_tview_data_request_cb(GtkWidget *, GdkDragContext *, GtkSelectionData *, guint, guint, dnd_item *);


#endif
