/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_dnd_tview.h,v 1.7 2003/02/24 15:51:20 thepin Exp $
 */

#ifndef _GUI_DND_TVIEW_H
#define _GUI_DND_TVIEW_H

#define DNDTVIEW_HILINE 0x1
#define DNDTVIEW_HIRECT 0x2


typedef struct {
	   int depth;
		int *rows;
} dnd_row;

typedef struct {
	GdkColor *hilights[10];
	gint hilight[10];
	gboolean scroll;
} dnd_tview_item;

typedef struct {
	int type;
} t_item;


/* prototypes */
dnd_tview_item *gui_dnd_tview_item_new();
void gui_dnd_tview_enable(GtkTreeView *);
void gui_dnd_tview_scroll_set(GtkTreeView *, gboolean);
void gui_dnd_tview_highlight_add(GtkTreeView *, int, char *, int);
void gui_dnd_tview_interaction(GtkTreeView *, GtkTreeView *,
			       gpointer, GdkDragAction);
void gui_dnd_tview_begin_selected(GtkTreeModel *, GtkTreePath *,
				  GtkTreeIter *, gpointer);
void gui_dnd_tview_data_request_selected(GtkTreeModel *, GtkTreePath *,
					 GtkTreeIter *, gpointer);


#endif
