/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_ftp_lookup.h,v 1.4 2003/02/24 15:51:22 thepin Exp $
 */

#ifndef _GUI_FTP_LOOKUP_H
#define _GUI_FTP_LOOKUP_H
/* local headers. */
#include <ftp.h>

typedef struct gui_ftp_lookup gui_ftp_lookup;


/* types. */
#define FTP_MODE_FTP	0x1
#define FTP_MODE_FXP	0x2

struct gui_ftp_lookup {
	int mode;					/* type, is it in fxp or ftp mode? */
	int state;					/* state, is it connected? */
	GtkWidget *widget;
	_ftp_item *site;
	struct gui_ftp_lookup *next;
};

/* prototypes. */
gui_ftp_lookup *gui_ftp_lookup_get_head();
gui_ftp_lookup *gui_ftp_lookup_add(_ftp_item *, GtkWidget *, int, int);
int gui_ftp_lookup_remove(gui_ftp_lookup *);
gui_ftp_lookup *gui_ftp_lookup_widget(GtkWidget *);
gui_ftp_lookup *gui_ftp_lookup_site(_ftp_item *);


#endif
