/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_player.h,v 1.10 2003/02/24 15:51:30 thepin Exp $
 */

#ifndef _GUI_PLAYER_H
#define _GUI_PLAYER_H

#include <ftp.h>

typedef struct t_song _song;
struct t_song {
	int type;
	_song *next;
	_song *child;
	_song *parent;
	char  *file;
	char  *pathfile;
};

void        gui_player_setup(GtkWidget *);
GtkWidget * gui_player_list_setup(GtkWidget *, GtkWidget *);

void gui_player_show();
void gui_player_hide();
void gui_player_changed(GtkRange *range, gpointer data);

_song * gui_player_list_song_new(char *);
void    gui_player_list_song_free(_song *);
void    gui_player_list_fill_cb(GtkTreeModel *, struct _list *, GtkTreeIter *);
void    gui_player_list_play();
void    gui_player_yosh_sucks();

#if 0
void gui_player_display_filebrowser();
void gui_player_filebrowser_ok(GtkWidget *w, GtkFileSelection *fs);
#endif 

#endif
