/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_preferences.h,v 1.3 2003/02/24 15:51:31 thepin Exp $
 */

#ifndef _GUI_PREFERENCES_H
#define _GUI_PREFERENCES_H
#include <gtk/gtk.h>

#define MAXP_OPT	8	

struct gui_prefsie {
	char *name;
	void (*filler)();
	enum { PREF_TREE, PREF_NORMAL } type;	
};


struct gui_pref_list {
	int booh;
	struct gui_pref_list *tnext, *parent, *child;
	char *name;
	char *treepath;
	int pindex;		/* index to the prefs_list table. */
	int slaves;		/* slaves, entries added under this entry (only applies to trees). */
	int notebook;		/* only for normal entries, the number of the notebook they represent. */
	struct gui_pref_list *next;
};

struct gui_pref_list *gui_find_category(char *, struct gui_pref_list *);
struct gui_pref_list *gui_preferences_parse_table();
GtkWidget *gui_preferences_tview_setup(GtkWidget *, struct gui_pref_list **);
struct gui_pref_list *gui_preferences_category_tview_initialize(GtkWidget *);
void gui_preferences_category_append(struct gui_pref_list **plist, const char *name, char *treepath, int index);
void gui_preferences_category_list_append_cb(GtkTreeModel *model, struct gui_pref_list *plist, GtkTreeIter *iter);
void gui_prefs_theme_show_cb(GtkTreeView *tree, GtkTreePath *path, GtkTreeViewColumn *column, gpointer data);
void gui_preferences_category_tree_row_select_cb(GtkTreeSelection *select, GtkTreeView *tree);



#endif

