/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_siteman.h,v 1.19 2003/03/03 02:16:32 tgucio Exp $
 */

#ifndef GUI_SITEMAN_H
#define GUI_SITEMAN_H

#define	ARROW_UP	1
#define ARROW_DOWN	0

#define SITEMAN_SITE  0
#define SITEMAN_GROUP 1

#include <jio.h>

struct slist {
	int            type;  		/* SITEMAN_SITE - SITEMAN_GROUP */
   struct slist   *next;
   struct slist   *child;
   struct slist   *parent;
   char           *profile;
	char           *hostaddr;
	char           *userid;
	char           *passwd;
	char           *port;
	GtkTreeView    *tree;
};

void            gui_siteman_startup(GtkButton *, char *);
void            gui_siteman_init(void);
GtkTreeView    *gui_siteman_setup_tree(GtkWidget *, GtkWidget *);
void            gui_siteman_check_pass(GtkWidget *, GtkEntry *);
void            gui_siteman_set_pass(GtkWidget *, GtkEntry *);
void            gui_siteman_change_pass(GtkWidget *, GtkEntry *);
void            gui_siteman_password_handler(GtkWidget *, char *);
int             gui_siteman_read_sites(void);
void            gui_siteman_write_sites_cb(GtkWidget *, gpointer);
void		    gui_siteman_widget_destroy_cb(GtkWidget *, gpointer);
void            gui_siteman_fprintf(jio *, struct slist *, GtkTreeIter);
void            gui_siteman_fprintf_slist(jio *, struct slist *, char*);
void            gui_siteman_delete_site_cb(GtkWidget *, GtkTreeView *);
void            gui_siteman_tree_row_select_cb(GtkTreeSelection *, GtkWidget *);
gboolean        gui_siteman_connect_site_cb(GtkWidget *, gpointer);
void            gui_siteman_tview_list_append_cb(gpointer *, 
		                                           struct slist *, gchar *);
struct slist   *gui_siteman_parse_sites(char *);
void            gui_siteman_entry_cb(GtkWidget *, GtkEntry **);
void            gui_siteman_create_site_cb(GtkWidget *, int);
void            gui_test_cb(GtkWidget *, struct slist *);
void *          gui_siteman_error(struct slist *, int);
gboolean        gui_siteman_destroy_cb(GtkTreeView *, GtkTreePath *,
		                                 GtkTreeViewColumn *, gpointer);
gboolean        gui_siteman_create_grp(GtkWidget *, int);
void            gui_siteman_create_grp_cb(GtkWidget *, GtkEntry *);
void            gui_siteman_edit_grp_cb(GtkWidget *, GtkEntry *);
void            gui_siteman_edit_site_cb(GtkWidget *, GtkEntry **);
void            gui_siteman_free(struct slist *);
void            gui_siteman_free_node(struct slist *);
void            gui_siteman_dnd_setup();
void            gui_siteman_move(GtkWidget *widget, GdkDragContext *dc,
		                           gint x, gint y, guint t, GSList *glist);
void            gui_siteman_move_item(struct slist *, struct slist *,
		                                GtkTreePath *,  GtkTreePath *);
void            gui_siteman_move_tview(GtkTreeRowReference *, 
	                                 GtkTreeRowReference *, 
					GtkTreeRowReference *, 
					int);
void            gui_siteman_list_append_cb(GtkTreeModel *model,
                                           struct slist * site,
                                           GtkTreeIter  * iter);
void            gui_siteman_move_cb(GtkTreeModel *model,
                                    GtkTreeIter, GtkTreeIter *, GtkTreeIter *);

void            gui_siteman_node_collapsed_cb(GtkTreeView *,
		                                      GtkTreeIter *, GtkTreePath *,
											  gpointer);
void            gui_siteman_node_expanded_cb(GtkTreeView *,
		                                     GtkTreeIter *, GtkTreePath *,
											 gpointer);
#endif
