/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_statusbar.h,v 1.8 2003/02/24 15:51:37 thepin Exp $
 */


#ifndef _GUI_STATUSBAR_H
#define _GUI_STATUSBAR_H
#include <ftp.h>
#include <medium.h>

typedef struct {
	GtkWidget *frame;
	GtkWidget *hbox;	/* horizontal container */
	GtkWidget *state;	/* Connected/Not Connected ... */
	GtkWidget *pbar;	/* processbar */
	GtkWidget *label;	/* When dling shows kbps */
	GtkWidget *label2;	/* ETA */
	GtkWidget *label3;  /* ETA queue */
	int timeout; /* timeout tag */
} status_bar;


GtkWidget *gui_statusbar_setup();
void gui_statusbar_update_connect(int);
void gui_statusbar_update(_ftp_item *);
void gui_statusbar_del_timeout();
int gui_medium_statusbar_trfr_update(MEDIUM_ARGS);
void gui_statusbar_label_change(GtkEventBox *, GdkEvent *, GObject *);
//XXX move me te misc.h
double time_usec();
#endif
