/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_toolbar.h,v 1.1 2003/02/26 04:32:19 thepin Exp $
 */

#ifndef _GUI_TOOLBAR_H
#define _GUI_TOOLBAR_H

#include <gtk/gtk.h>

enum {
	GUI_JUSTIFY_LEFT,
	GUI_JUSTIFY_RIGHT
};

typedef struct gui_toolbar gui_toolbar;
typedef struct gui_toolbar_child gui_toolbar_child;

struct gui_toolbar {
	GtkWidget *frame;
	GtkWidget *hbox;
	GList *children;
	unsigned int n_children;
};

struct gui_toolbar_child {
	GtkWidget *widget;
	GtkWidget *label;
	GtkWidget *icon;
	GtkWidget *box;
	int alignment;
	int resize;
};



/* prototypes */
void gui_toolbar_destroy_cb(GObject *, gpointer);
GtkWidget *gui_toolbar_new();
gui_toolbar *gui_toolbar_free(gui_toolbar *);
gui_toolbar_child *gui_toolbar_child_new();
gui_toolbar_child *gui_toolbar_child_free(gui_toolbar_child *);
void gui_toolbar_append_widget(GtkWidget *, int, int, GtkWidget *);
void gui_toolbar_append_item(GtkWidget *, int, const char *, GtkWidget *, GtkSignalFunc, gpointer);


#endif
