/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: jlist.h,v 1.7 2003/02/24 15:51:41 thepin Exp $
 */

#ifndef _JLIST_H
#define _JLIST_H

#include <misc.h>

typedef struct _jslist jslist;
struct _jslist {
	void   *data;
	jslist *next;
};

jslist * jslist_add       (jslist *, void *);
void     jslist_free      (jslist *);
jslist * jslist_free_list (jslist *, cb);
jslist * jslist_append    (jslist *, void *);



typedef struct t_record {
   int type;
   struct t_record *next;
   struct t_record *child;
   struct t_record *parent;
   // other members not directly accessed by this func
} t_tree;

typedef struct _iter {
	int depth;
	int n[10];
} t_iter;

t_iter * jtree_iter_new    ();
void     jtree_iter_free   (t_iter *);
t_iter * jtree_iter_child  (t_iter *);
t_iter * jtree_iter_parent (t_iter *);

void   jtree_iterate (void *, t_iter *, cb, int, void *);
void * jtree_append_from_path  (void *, void *, char *);
void * jtree_remove (void *, void *, cb);
#endif
