/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: log.h,v 1.4 2003/02/24 15:51:43 thepin Exp $
 */

#ifndef _LOG_H
#define _LOG_H

#include <ftp.h>

#define MODE_FTP_SENT	0x1
#define MODE_FTP_RECV	0x2
#define MODE_FTP_MISC	0x3
#define MODE_ERROR	0x4
#define MODE_MISC	0x5

int log_setup(void (*));
int log_init();
extern void (*log_cmd)(_ftp_item *, int, const char *, ...);

#define FTP_SENT_LOG(ftp, x, arg...) 								\
	if (log_init()) log_cmd(ftp, MODE_FTP_SENT, x, ## arg)

#define FTP_RECV_LOG(ftp, x, arg...)									\
	if (log_init()) log_cmd(ftp, MODE_FTP_RECV, x, ## arg)

#define FTP_MISC_LOG(ftp, x, arg...)									\
	if (log_init()) log_cmd(ftp, MODE_FTP_MISC, x, ## arg)

#define MISC_LOG(ftp, x, arg...)									\
	if (log_init()) log_cmd(ftp, MODE_MISC, x, ## arg)

#define ERROR_LOG(ftp, x, arg...)									\
	if (log_init()) log_cmd(ftp, MODE_ERROR, x, ## arg)


#endif
