/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: medium.h,v 1.8 2003/02/24 15:51:44 thepin Exp $
 */

#ifndef _MEDIUM_H
#define _MEDIUM_H

/* Types */
#define M_TRFR_UPDATE		0x1		/* Update transfer information / Percentage.. */
#define M_SELECT_READ		0x2		/* Takes 1 argument (fd) */
#define M_SELECT_WRITE		0x3		/* 1 argument (fd) */
#define M_PATHS_UPDATE		0x4		/* Update paths */
#define M_SELECT_WAIT  		0x5		/* 1 argument (time) */
#define M_TIMEOUT_ADD		0x6		/* add a timeout (3 args: time, callback, extra data).  /Callback/ will be called after /seconds/. */
#define M_FTP_CONNECTING	0x7
#define M_FTP_CONNECTED		0x8
#define M_SELECT_READ_2		0x9
#define M_IO_WATCH		0xA
#define M_TIMEOUT_REMOVE	0xB

#define MEDIUM(x)		((x) ? (&(x->medium)) : (NULL))
#define MEDIUM_FUNC(x)		int (*x)()
#define MEDIUM_ARGS		void **medium_args
#define MEDIUM_ARG(x)		(medium_args[x])


typedef struct medium_struct medium;


struct medium_list {
	int type;
	int args;
};

struct medium_struct {
	int type;
	MEDIUM_FUNC(function);
	struct medium_struct *next;	
};

/* prototypes */
int medium_set_function(int, MEDIUM_FUNC(x));
void medium_free(void);
void *medium_next(medium *, int);
int medium_cmd(int, int *, ...);
medium *medium_find(int);


#endif
