/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: sound_handlers.h,v 1.3 2003/02/24 15:51:47 thepin Exp $
 */


#ifndef _SOUND_HANDLERS_H
#define _SOUND_HANDLERS_H

#include <sound.h>

/* keep the sound handlers (ie. esd, libmikmod, vorbis) in a list.*/
struct sound_handler {
	char *handler;
	char *formats;		/* all format extensions in lowercase seperated by 
				   ' ' (also add ' ' before and after string for 
				   strstr purposes) */
	
	/* functions. */
	int (*startup)(void);
	void (*shutdown)(void);
	int (*preload)(char *, char *);
	int (*play_event)(struct sound_list *);
	int (*play_path)(char *, cb);
	int (*stop)(void);

	struct sound_handler *next;
};


/* function prototypes. */
// void sound_handler_add(const char *, int, const char *, int (*)(), void (*)(), int (*)(), int (*)(), int (*)(), int (*)());
struct sound_handler *sound_handler_find_by_extension(char *);
struct sound_handler *sound_handler_find_by_filename(char *);
struct sound_handler *sound_handler_find_by_name(char *);
void sound_handler_all_init(void);
void sound_handler_all_shutdown(void);
void sound_handler_all_stop(void);
void sound_handler_setup(void);

#endif
