/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: debug.c,v 1.1 2003/03/03 02:35:05 tgucio Exp $
 */


#include <stdio.h>
#include <stdarg.h>
/* local headers */
#include <debug.h>
#include <medium.h>
#include <error.h>


const char debugfilename[] = DEBUGFILENAME;


void debug(int debuglevel, char *file, int line, const char *mf, ...)
{
   va_list va;
   char    msg[256];

   va_start(va, mf);
   
   vsnprintf(msg, sizeof (msg), mf, va);

   fprintf(stderr, "%s, l %d: %s\n", file, line, msg);

   va_end(va);  
}

#if 0
void debug_init(void)
{
   int debugfd;

   debugfd = open(debugfilename, O_WRONLY | O_CREAT | O_APPEND,
                    S_IRUSR | S_IWUSR);
   if (debugfd == -1)
   {
      /* Weird, but couldn't open... Try /dev/null at least. */
      debugfd = open("/dev/null", O_WRONLY);
      if (debugfd == -1)
         fatal("Could not open debug file nor /dev/null");
   }

   if (debugfd != STDERR_FILENO)
   {
      dup2(debugfd, STDERR_FILENO);
      close(debugfd);
   }
}
#endif
