/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_anti_idler.c,v 1.7 2003/03/03 02:16:33 tgucio Exp $
 */


#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <gtk/gtk.h>
#include <strings.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <math.h>
/* local headers */
#include <gui.h>
#include <ftp.h>
#include <ftp_object.h>
#include <medium.h>
#include <error.h>
#include <sys/time.h>
#include <gui_anti_idler.h>
#include <anti_idler.h>
#include <config.h>


gboolean
gui_anti_idler_timeout(gpointer data)
{
	DEBUG_MSG(DBG_INFO, "gui_anti_idler_timeout");
	anti_idle_iterator(data);
	return TRUE;
}

void
gui_anti_idler_toggle(_ftp_item *ftp, gboolean state)
{
	int timeout_id, timeout;

	DEBUG_MSG(DBG_INFO, "gui_anti_idler_toggle, ftp: %p state: %d", ftp, state);
	timeout = config_read_num("anti-idler");
	timeout_id = (int)ftp_object_get_data(FTP_OBJECT(ftp), "anti_idle_timeout");
	if (state == TRUE && !timeout_id) {
		if (!timeout)
			return;

		timeout_id = gtk_timeout_add(timeout*1000, gui_anti_idler_timeout, ftp); 
		ftp_object_set_data(FTP_OBJECT(ftp), "anti_idle_timeout", (void *)timeout_id);
	} else if (state == FALSE) {
		if (timeout_id)
			gtk_timeout_remove(timeout_id);

		ftp_object_unlink_tag(FTP_OBJECT(ftp), "anti_idle_timeout");
	}

	return;
}


