
/* junkie - gui ftp client
 * Copyright (c) 2002-2003, Gunnsteinn Hall, Joel Thomas, Martin Faxer
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of the
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
 *  HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 *  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * $Id: gui_player.c,v 1.26 2003/03/07 17:48:12 thepin Exp $
 */


#define _GNU_SOURCE

#include <gtk/gtk.h>
#include <stdio.h>
#include <string.h>
/* local headers */
#include <configure.h>
#include <gui_widgets.h>
#include <gui_player.h>
#include <gui_treestore.h>
#include <gui_popup.h>
#include <gui_toolbar.h>
#include <gui_toolkit.h>
#include <gui_misc.h>
#include <sound.h>
#include <sound_mixer.h>
#include <local.h>
#include <config.h>
#include <mem.h>

#ifdef HAVE_SOUND

static GtkWidget *player;
static GtkWidget *scrolled;

void ya_lame() {}

void
gui_player_setup(GtkWidget *menubar)
{
	GtkWidget *playlist;
	GtkWidget *mainbox, *hbox, *vbox;
	GtkWidget *play, *pause;
	GtkWidget *scale;
	GtkObject *adjust;
	int value;
//	GList *children;

	mainbox = gtk_hbox_new(0, 3);
	
	hbox    = gtk_hbox_new(1, 0);

	vbox    = gtk_vbox_new(0, 0);
	gtk_container_set_border_width(GTK_CONTAINER(mainbox), 2);

	gtk_box_pack_end(GTK_BOX(mainbox), vbox,     0, 0, 0);
	
	adjust = gtk_adjustment_new(0, 0, 101, 1, 0, 0);
	scale = gtk_hscale_new(GTK_ADJUSTMENT(adjust));
	gtk_scale_set_draw_value(GTK_SCALE(scale), 0);

	play = gtk_button_new_with_label("play"); 
	pause = gtk_button_new_with_label("stop");

	gtk_box_pack_start(GTK_BOX(vbox), scale, 0, 0, 0);
	gtk_box_pack_end(GTK_BOX(vbox), hbox,  0, 0, 0);

	gtk_box_pack_start(GTK_BOX(hbox), play , 1, 1, 0);
	gtk_box_pack_start(GTK_BOX(hbox), pause, 1, 1, 0);


	playlist = gui_player_list_setup(menubar, mainbox);
//	gtk_menu_attach_to_widget(GTK_MENU(playlist), mainbox, ya_lame);
//	gtk_menu_popup(GTK_MENU(playlist), 0, 0, 0, 0, 0, 0);
	
	g_signal_connect(G_OBJECT(play), "pressed",
			G_CALLBACK(gui_player_list_play), playlist);
	g_signal_connect(G_OBJECT(pause), "pressed",
			 G_CALLBACK(sound_stop), NULL);

	value = sound_mixer_volume_get();
	gtk_range_set_value(GTK_RANGE(scale), value);
	g_signal_connect(G_OBJECT(scale), "value_changed",
			G_CALLBACK(gui_player_changed), NULL);

	
	
	

	gui_insert_widget("player", mainbox);
	player = mainbox;
	gtk_widget_show_all(mainbox);
		
	
//	children = GTK_TOOLBAR(menubar)->children;
//	vbox = g_list_last(children)->data;
//	gtk_container_remove(&(GTK_TOOLBAR(menubar)->container), vbox);
//	g_list_free(children);
//	gtk_box_pack_start(GTK_BOX(menubar), 
//			vbox, 0, 0, 0);	

	if(!config_read_bool("show_player"))
	       gui_player_hide();
	
}

void gui_player_show()
{
	gtk_widget_show(player);
}

void gui_player_hide()
{
	gtk_widget_hide(player);
}



void
gui_player_changed(GtkRange *range, gpointer data)
{
	char value = gtk_range_get_value(range);
	sound_mixer_volume_set(value, value);
}

#if 0
void
gui_player_display_filebrowser()
{
	GtkWidget* browser;
	browser = gtk_file_selection_new ("select the sound to play");
	gtk_widget_show(browser);

	g_signal_connect(G_OBJECT(GTK_FILE_SELECTION(browser)->ok_button),
			"pressed", G_CALLBACK(gui_player_filebrowser_ok), browser);
	g_signal_connect(G_OBJECT(GTK_FILE_SELECTION(browser)->cancel_button),
			"pressed", G_CALLBACK(gui_widget_destroy_cb), browser);
}

void
gui_player_filebrowser_ok(GtkWidget *w, GtkFileSelection *fs)
{
	const gchar *file = gtk_file_selection_get_filename(fs);
	sound_play_path(file, 1);
	gtk_widget_destroy(GTK_WIDGET(fs));
}
#endif

void gui_player_yosh_sucks() { 
	GList *children;
	GtkTreePath *path = gtk_tree_path_new_from_string("0");
	DEBUG_MSG(DBG_INFO, "i'm done!");
	children = gtk_container_get_children(GTK_CONTAINER(scrolled));
	gui_treestore_remove(GTK_TREE_VIEW(children->data), path);
	gui_treestore_remove_list(GTK_TREE_VIEW(children->data), path, gui_player_list_song_free);
	gtk_tree_path_free(path);
	gui_player_list_play();
}

void
gui_player_list_play()
{
	GList *children;
	_song *song;
	char  *file;
	children = gtk_container_get_children(GTK_CONTAINER(scrolled));
	song     = gui_treestore_get_list(gtk_tree_view_get_model(children->data));
	if(!song)	return;
	file = song->pathfile;
	DEBUG_MSG(DBG_INFO, "playing %s", file);
	sound_play_path(file, 1, gui_player_yosh_sucks);
}

GtkWidget *
gui_player_list_setup2()
{
	GtkWidget *menu, *item;
	menu = gtk_menu_new();
	
	item = gtk_menu_item_new_with_label("lalala");
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);
	
	gtk_widget_show(menu);
	return menu;
}

GtkWidget *
gui_player_list_setup(GtkWidget *menubar, GtkWidget *mainbox)
{
	GtkTreeView          *tree     = 0;
	GtkTreeModel         *model    = 0;
	GtkTreeStore         *store    = 0;
	GtkTreeViewColumn    *column   = 0;
	GtkCellRenderer      *renderer = 0;
	GtkStyle             *style    = 0;
	GdkColor             *color    = 0;
	GdkWindow            *win      = 0;
	PangoFontDescription *font     = 0;
	int                   size     = 0;
	
	
	store = gtk_tree_store_new(1, G_TYPE_STRING);
	model = GTK_TREE_MODEL(store);
	tree  = GTK_TREE_VIEW(gtk_tree_view_new_with_model(model));
	gtk_tree_view_set_headers_visible(tree, 0);
//	gtk_widget_set_size_request(GTK_WIDGET(tree), 0, -1);
	scrolled = gui_setup_scrolled_window(GTK_POLICY_NEVER,
			                             GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER(scrolled), GTK_WIDGET(tree));
		
	gtk_box_pack_start(GTK_BOX(mainbox), scrolled, 0, 0, 0);

	gui_toolbar_append_widget(menubar, GUI_JUSTIFY_RIGHT, FALSE, mainbox);
	
	
	/* set up the font */
	style = gtk_widget_get_style(GTK_WIDGET(tree));
	font = pango_font_description_copy(style->font_desc);
	size = pango_font_description_get_size(font);
	DEBUG_MSG(DBG_INFO, "size = %d, new = %d", size, size / 2);
	pango_font_description_set_size(font, size/2);
	gtk_widget_modify_font(GTK_WIDGET(tree), font);
	pango_font_description_free(font);

	/* set up the cell renderer bg */
	style = gtk_widget_get_style(menubar);
	color = j_malloc(sizeof(GdkColor));
	memset(color, 0, sizeof(GdkColor));
	*color = style->bg[GTK_STATE_NORMAL];
	renderer = gtk_cell_renderer_text_new();
	g_object_set(renderer, "background_gdk", color, NULL);	
	gtk_widget_realize(GTK_WIDGET(tree));
	win = gtk_tree_view_get_bin_window(tree);
	gdk_colormap_alloc_color(
			gdk_colormap_get_system(), color, 1, 1);
	gdk_window_set_background(win, color);

	/* set up the cell y padding */
	g_object_get(renderer, "ypad", &size, NULL);
	g_object_set(renderer, "ypad", size/2, NULL);
	
	/* column for the song */
	column   = gtk_tree_view_column_new_with_attributes(
			"Songs", renderer, "text", 0, NULL);
	gtk_tree_view_append_column(tree, column);

	return GTK_WIDGET(scrolled);
}

void
gui_player_list_fill_cb(GtkTreeModel *model, struct _list *list, GtkTreeIter *iter)
{
	gtk_tree_store_set(GTK_TREE_STORE(model), iter, 0, list->file, -1);
}

_song * 
gui_player_list_song_new(char *file)
{
	_song *song = 0;
	song = j_malloc(sizeof(_song));
	memset(song, 0, sizeof(_song));
	song->file = j_strdup(file);
	song->pathfile = j_asprintf("%s/%s", local_pwd(), file);
	return song;
}

void
gui_player_list_song_free(_song *song)
{
	j_free(song->file);
	j_free(song->pathfile);
	j_free(song);
}

#endif
